package nc.ui.gl.assattributebanlance;

import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.lang.reflect.Constructor;
import java.util.Hashtable;
import javax.swing.DefaultCellEditor;
import javax.swing.JFrame;
import nc.bs.logging.Logger;
import nc.ui.bd.b02.BdinfoBO_Client;
import nc.ui.bd.def.DefaultDefdocRefModel;
import nc.ui.bd.ref.AbstractRefModel;
import nc.ui.gl.assattributebanlance.QryObjectList;
import nc.ui.glcom.ass.AssRefPanel;
import nc.ui.glcom.ass.RefModel;
import nc.ui.glcom.control.GlComboBox;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.UIComboBox;
import nc.ui.pub.beans.UITablePane;
import nc.ui.pub.beans.table.VOTableModel;
import nc.vo.bd.b02.BdinfoVO;
import nc.vo.glcom.ass.AssVO;
import nc.vo.glcom.balance.GLQueryObj;
import nc.vo.pub.ValueObject;

public class AssAttributeList extends UITablePane {

   private AssAttributeList.AssAttributeListTableModel m_tableModel = null;
   private UIComboBox ivjCBDisPosition = null;
   private Hashtable hashTblRefValues = new Hashtable();
   private GlComboBox ivjGLCBQryObject = null;
   private ClientEnvironment env = null;
   private BdinfoVO[] refData1 = null;
   private String[] showName = null;
   private String pk_corp = null;
   private String strCurrentObjName = null;


   public AssAttributeList() {
      this.initialize();
   }

   public AssAttributeList(int vsbPolicy, int hsbPolicy) {
      super(vsbPolicy, hsbPolicy);
   }

   public void fireStopEditing() {
      for(int j = 0; j < 3; ++j) {
         for(int i = 0; i < 3; ++i) {
            this.getTable().getCellEditor(j, i).stopCellEditing();
         }
      }

   }

   private UIComboBox getCBDisPosition() {
      if(this.ivjCBDisPosition == null) {
         try {
            this.ivjCBDisPosition = new UIComboBox();
            this.ivjCBDisPosition.setName("CBDisPosition");
            this.ivjCBDisPosition.setLocation(26, 467);
            this.ivjCBDisPosition.addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000197"));
            this.ivjCBDisPosition.addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000192"));
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjCBDisPosition;
   }

   private GlComboBox getGLCBQryObject() {
      if(this.ivjGLCBQryObject == null) {
         try {
            this.ivjGLCBQryObject = new GlComboBox();
            this.ivjGLCBQryObject.setName("GLCBQryObject");
            this.ivjGLCBQryObject.setLocation(187, 464);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjGLCBQryObject;
   }

   public String getPk_corp() {
      if(this.pk_corp == null) {
         this.pk_corp = this.env != null?this.env.getCorporation().getPk_corp():ClientEnvironment.getInstance().getCorporation().getPk_corp();
      }

      return this.pk_corp;
   }

   public String getStrCurrentObjName() {
      return this.strCurrentObjName;
   }

   public AssAttributeList.AssAttributeListTableModel getTableModel() {
      if(this.m_tableModel == null) {
         try {
            GLQueryObj[] e = new GLQueryObj[30];

            for(int i = 0; i < 30; ++i) {
               e[i] = new GLQueryObj();
            }

            this.m_tableModel = new AssAttributeList.AssAttributeListTableModel(e);
            this.m_tableModel.setQuryObjVOs(e);
         } catch (Exception var3) {
            var3.printStackTrace();
         }
      }

      return this.m_tableModel;
   }

   private void handleException(Throwable exception) {
   }

   private void initData() {
      try {
         this.getGLCBQryObject().removeAllItems();
         this.getGLCBQryObject().addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"), (Object)null);
         this.refData1 = BdinfoBO_Client.queryAll(this.getPk_corp(), "");
         if(this.refData1 != null && this.refData1.length != 0) {
            this.showName = new String[this.refData1.length];

            for(int e = 0; e < this.showName.length; ++e) {
               this.showName[e] = this.refData1[e].getBdname();
               this.getGLCBQryObject().addItem(this.showName[e], this.refData1[e]);
            }
         }
      } catch (Exception var2) {
         var2.printStackTrace();
      }

   }

   private void initialize() {
      try {
         this.setName("QryObjectList");
         this.setSize(453, 403);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

      this.getTable().setModel(this.getTableModel());
      this.getTable().setCellSelectionEnabled(true);
      this.getTable().setAutoResizeMode(0);
      DefaultCellEditor positionEditer = new DefaultCellEditor(this.getCBDisPosition());
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")).setCellEditor(positionEditer);
      DefaultCellEditor qryObjEditer = new DefaultCellEditor(this.getGLCBQryObject());
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000458")).setCellEditor(qryObjEditer);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000458")).setPreferredWidth(90);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000458")).setWidth(90);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setPreferredWidth(200);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setWidth(200);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")).setPreferredWidth(55);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")).setWidth(55);
      this.initData();
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         QryObjectList aQryObjectList = new QryObjectList();
         exception.setContentPane(aQryObjectList);
         exception.setSize(aQryObjectList.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.gl.assattributebanlance.QryObjectList 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void newMethod() {
      Logger.debug("");
   }

   public void refresh(String newPk_corp) {
      this.setPk_corp(newPk_corp);
      this.initialize();
   }

   public void setPk_corp(String newPk_corp) {
      this.pk_corp = newPk_corp;
   }

   public void setStrCurrentObjName(String newStrCurrentObjName) {
      this.strCurrentObjName = newStrCurrentObjName;
   }

   private void setValueRef(int row) {
      try {
         GLQueryObj[] ex = this.getTableModel().getQuryObjVOs();
         int iCount = 0;
         int iIndexInVos = 0;
         boolean blnInVos = false;

         int i;
         for(i = 0; i < ex.length; ++i) {
            if(ex[i].getLinkObj() != null && ex[i].getLinkObj().equals(this.getStrCurrentObjName())) {
               if(iCount == row) {
                  iIndexInVos = i;
                  blnInVos = true;
                  break;
               }

               ++iCount;
            }
         }

         boolean var19 = false;

         for(i = 0; i < this.refData1.length && !ex[iIndexInVos].getType().equals(this.refData1[i].getBdname()); ++i) {
            ;
         }

         BdinfoVO bdinfoVO = this.refData1[i];
         String strNodeName = bdinfoVO.getRefnodename();
         String strBdName = bdinfoVO.getBdname();
         AssRefPanel assrefTemp = new AssRefPanel();
         if(!this.hashTblRefValues.containsKey(strBdName)) {
            if(strNodeName != null && !strNodeName.trim().equals("")) {
               assrefTemp.setRefNodeName(strNodeName);
               assrefTemp.getRefModel().setRefNodeName(strNodeName, this.pk_corp);
               String var22 = assrefTemp.getRefModel().getWherePart();
               if(bdinfoVO.getBdcode().startsWith("J")) {
                  assrefTemp.getRef().setRefType(0);
                  if(var22 != null && !var22.trim().equals("")) {
                     var22 = var22 + " and bd_jobtype.pk_jobtype = \'" + bdinfoVO.getPk_defdef() + "\'";
                  } else {
                     var22 = " bd_jobtype.pk_jobtype = \'" + bdinfoVO.getPk_defdef() + "\'";
                  }
               }

               assrefTemp.getRefModel().setWherePart(var22);
               assrefTemp.setMultiSelectedEnabled(true);
            } else if(bdinfoVO.getSelfrefclass() != null) {
               if(bdinfoVO.getIsdef().booleanValue()) {
                  DefaultDefdocRefModel model = (DefaultDefdocRefModel)Class.forName(bdinfoVO.getSelfrefclass()).newInstance();
                  model.setPkdefdef(bdinfoVO.getPk_defdef());
                  assrefTemp.setIsCustomDefined(true);
                  assrefTemp.setRefModel(model);
                  assrefTemp.setMultiSelectedEnabled(true);
               } else {
                  Class classTemp = Class.forName(bdinfoVO.getSelfrefclass());

                  try {
                     Constructor ee = null;

                     AbstractRefModel var20;
                     try {
                        ee = classTemp.getConstructor(new Class[]{String.class});
                        var20 = (AbstractRefModel)ee.newInstance(new Object[]{ClientEnvironment.getInstance().getCorporation().getPk_corp()});
                     } catch (NoSuchMethodException var16) {
                        var20 = (AbstractRefModel)classTemp.newInstance();
                     }

                     assrefTemp.setIsCustomDefined(true);
                     assrefTemp.setRefModel(var20);
                     assrefTemp.setMultiSelectedEnabled(true);
                  } catch (Exception var17) {
                     var17.printStackTrace();
                  }
               }
            } else {
               RefModel var21 = new RefModel();
               var21.setDefaultFieldCount(2);
               var21.setTableName(bdinfoVO.getBdname());
               var21.setBlurFields(new String[]{bdinfoVO.getCodefieldname()});
               var21.setFieldCode(new String[]{bdinfoVO.getCodefieldname(), bdinfoVO.getNamefieldname()});
               var21.setHiddenFieldCode(new String[]{bdinfoVO.getTablepkname()});
               var21.setTableName(bdinfoVO.getTablename());
               var21.setPkFieldCode(bdinfoVO.getTablepkname());
               if(bdinfoVO.getCorpfieldname() != null) {
                  var21.setWherePart(bdinfoVO.getCorpfieldname() + " =\'\'");
               }

               assrefTemp.setRefModel(var21);
               assrefTemp.setIsCustomDefined(true);
               assrefTemp.setMultiSelectedEnabled(true);
            }

            this.hashTblRefValues.put(strBdName, assrefTemp);
            this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor(assrefTemp);
         } else {
            this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor((AssRefPanel)this.hashTblRefValues.get(strBdName));
         }
      } catch (Exception var18) {
         var18.printStackTrace();
      }

   }

   public class AssAttributeListTableModel extends VOTableModel {

      String[] ColumnName = new String[]{NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000458"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")};
      private GLQueryObj[] m_vos = null;
      private Hashtable hashTblRefValues = new Hashtable();


      public AssAttributeListTableModel(ValueObject[] vos) {
         super(vos);
      }

      public AssAttributeListTableModel(Class c) {
         super(c);
      }

      public AssAttributeListTableModel(ValueObject vo) {
         super(vo);
      }

      public Class getColumnClass(int col) {
         return String.class;
      }

      public int getColumnCount() {
         return 3;
      }

      public String getColumnName(int col) {
         return this.ColumnName[col];
      }

      public GLQueryObj[] getQuryObjVOs() {
         return this.m_vos;
      }

      public int getRowCount() {
         return 3;
      }

      public Object getValueAt(int row, int col) {
         AssAttributeList.this.newMethod();
         GLQueryObj[] allVOs = (GLQueryObj[])((GLQueryObj[])this.getVOArray());
         GLQueryObj tempVO = new GLQueryObj();
         int iCount = 0;

         for(int aAssVo = 0; aAssVo < allVOs.length; ++aAssVo) {
            if(allVOs[aAssVo].getLinkObj() != null && allVOs[aAssVo].getLinkObj().equals(AssAttributeList.this.getStrCurrentObjName())) {
               if(iCount == row) {
                  tempVO = allVOs[aAssVo];
                  break;
               }

               ++iCount;
            }
         }

         switch(col) {
         case 0:
            return tempVO.getType();
         case 1:
            if(tempVO.getValueRange() == null) {
               return tempVO.getValueRange();
            }

            AssVO[] var9 = (AssVO[])tempVO.getValueRange();
            String strNames = "";

            for(int i = 0; i < var9.length; ++i) {
               strNames = strNames + "," + var9[i].getCheckvaluename();
            }

            return strNames.length() == 0?"":strNames.substring(1, strNames.length());
         case 2:
            if(tempVO.getHeadEle()) {
               return NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000197");
            }

            return NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000192");
         default:
            return null;
         }
      }

      public boolean isCellEditable(int row, int col) {
         if((col == 0 || this.getValueAt(row, 0) != null && !this.getValueAt(row, 0).equals("")) && AssAttributeList.this.getStrCurrentObjName() != null && !AssAttributeList.this.getStrCurrentObjName().trim().equals("")) {
            if(col == 0) {
               return true;
            } else if(col == 1) {
               if(this.getValueAt(row, 0).equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"))) {
                  if(!this.hashTblRefValues.containsKey(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"))) {
                     AssRefPanel assRefTmp = new AssRefPanel();
                     assRefTmp.setRefNodeName("会计科目");
                     assRefTmp.getRefModel().setRefNodeName("会计科目", AssAttributeList.this.pk_corp);
                     assRefTmp.getRefModel().addWherePart(" or (sealflag is not null and bd_accsubj.pk_corp=\'" + AssAttributeList.this.getPk_corp() + "\') ");
                     assRefTmp.setMultiSelectedEnabled(true);
                     this.hashTblRefValues.put(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"), assRefTmp);
                     AssAttributeList.this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor(assRefTmp);
                  } else {
                     AssAttributeList.this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor((AssRefPanel)this.hashTblRefValues.get(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031")));
                  }
               } else {
                  AssAttributeList.this.setValueRef(row);
               }

               return true;
            } else {
               return true;
            }
         } else {
            return false;
         }
      }

      public void setQuryObjVOs(GLQueryObj[] vos) throws Exception {
         this.clearTable();
         this.addVO(vos);
         this.m_vos = vos;
      }

      public void setValueAt(Object value, int r, int c) {
         AssAttributeList.this.newMethod();
         GLQueryObj[] allVOs = (GLQueryObj[])((GLQueryObj[])this.getVOArray());
         int iCount = 0;
         int iIndexInVos = 0;
         boolean blnInVos = false;

         int aAssVosTemp;
         for(aAssVosTemp = 0; aAssVosTemp < allVOs.length; ++aAssVosTemp) {
            if(allVOs[aAssVosTemp].getLinkObj() != null && allVOs[aAssVosTemp].getLinkObj().equals(AssAttributeList.this.getStrCurrentObjName())) {
               if(iCount == r) {
                  iIndexInVos = aAssVosTemp;
                  blnInVos = true;
                  break;
               }

               ++iCount;
            }
         }

         if(!blnInVos) {
            for(aAssVosTemp = 0; aAssVosTemp < allVOs.length; ++aAssVosTemp) {
               if(allVOs[aAssVosTemp].getLinkObj() == null) {
                  iIndexInVos = aAssVosTemp;
                  break;
               }
            }
         }

         switch(c) {
         case 0:
            if(value == null) {
               return;
            }

            this.getQuryObjVOs()[iIndexInVos].setType(value.toString());
            this.getQuryObjVOs()[iIndexInVos].setValueRange((AssVO[])null);
            this.getQuryObjVOs()[iIndexInVos].setLinkObj(AssAttributeList.this.getStrCurrentObjName());
            break;
         case 1:
            AssVO[] var11 = (AssVO[])((AssVO[])value);
            if(value != null && var11.length != 0) {
               var11 = (AssVO[])((AssVO[])value);
            } else {
               var11 = new AssVO[]{new AssVO()};
            }

            if(this.getQuryObjVOs()[iIndexInVos].getType() != null && !this.getQuryObjVOs()[iIndexInVos].getType().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"))) {
               int iIndex;
               for(iIndex = 0; iIndex < AssAttributeList.this.refData1.length && !this.getQuryObjVOs()[iIndexInVos].getType().equals(AssAttributeList.this.refData1[iIndex].getBdname()); ++iIndex) {
                  ;
               }

               for(int i = 0; i < var11.length; ++i) {
                  var11[i].setChecktypename(AssAttributeList.this.refData1[iIndex].getBdname());
                  var11[i].setPk_Checktype(AssAttributeList.this.refData1[iIndex].getPk_bdinfo());
                  var11[i].setChecktypecode(AssAttributeList.this.refData1[iIndex].getBdcode());
               }
            }

            this.getQuryObjVOs()[iIndexInVos].setValueRange(var11);
            break;
         case 2:
            if(value.toString().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000197"))) {
               this.getQuryObjVOs()[iIndexInVos].setHeadEle(true);
            } else if(value.toString().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000192"))) {
               this.getQuryObjVOs()[iIndexInVos].setHeadEle(false);
            }
         }

      }
   }
}
